/*
 * Copyright (c) 1997 Dustin Sallings
 *
 * $Id: disk.h,v 1.5 1997/09/10 06:28:12 dustin Exp $
 */

#include <config.h>

#include <stdio.h>
#include <ctype.h>
#include <sys/types.h>

#ifdef HAVE_SYS_VFS_H
#include <sys/vfs.h>
#endif

#ifdef HAVE_SYS_LIMITS_H
#include <sys/limits.h>
#endif /* HAVE_SYS_LIMITS_H */

#ifdef HAVE_SYS_STATFS_H
#include <sys/statfs.h>
#endif

#ifdef HAVE_SYS_STATVFS_H
#include <sys/statvfs.h>
#endif

#ifdef HAVE_SYS_PARAM_H
#include <sys/param.h>
#endif

#ifdef HAVE_SYS_MOUNT_H
#include <sys/mount.h>
#endif

/* It was this way on my Indy */


#if !defined(_AIX) && !defined(__osf__)
# ifdef HAVE_STATVFS
#  define statfs statvfs
# endif
#endif

#if defined(__FreeBSD__) || defined(__osf__)
# define INT_FSTYPES 1
# undef  STRING_FSTYPES
#else
# define STRING_FSTYPES 1
# undef  INT_FSTYPES
#endif

/* Bad filesystem types, don't report on these. */

#ifdef STRING_FSTYPES
static char *badfstypes[]={
    "auto",
    "autofs",
    "fd",
    "kern",
    "nfs",
    "proc",
    "tmpfs",
    NULL
};
#endif

#ifdef INT_FSTYPES
static int badfstypes[]={
#ifdef MOUNT_FDESC
    MOUNT_FDESC,
#endif
#ifdef MOUNT_KERNFS
    MOUNT_KERNFS,
#endif
#ifdef MOUNT_PROCFS
    MOUNT_PROCFS,
#endif
    MOUNT_MFS,
    MOUNT_NFS,
    0
};
#endif

struct diskret {
    long  total;
    long  used;
    long  free;
    long  bs;
    float percent;
};

/* 1k block size */
#define BS 1024

/* types to pass to domtab */
#define DO_DISPLAY 1
#define NO_DISPLAY 2

/* Yeah, I know, stolen from BSD source code. */

#define bsdfsbtoblk(num, fsbs, bs) \
        (((fsbs) != 0 && (fsbs) < (bs)) ? \
                (num) / ((bs) / (fsbs)) : (num) * ((fsbs) / (bs)))

#ifndef PATH_MAX
#ifdef _POSIX_PATH_MAX
#define PATH_MAX _POSIX_PATH_MAX
#else
#define PATH_MAX 4096
#endif /* _POSIX_PATH_MAX */
#endif /* PATH_MAX */
