/*
 * Copyright (c) 1997  Dustin Sallings
 *
 * $Id: pipe.c,v 1.4 1997/07/30 03:22:22 dustin Exp $
 */

#include <config.h>

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>

#ifndef MAX_ARGS
#define MAX_ARGS 512
#endif

#ifdef BSDPS
# define DEFAULTPS BSDPS
#else
# define DEFAULTPS SYSVPS
#endif

void runCommand(char *prog)
{
    char *argv[MAX_ARGS];
    int i;

    argv[0]=strtok(prog, " ");

    for(i=1; i<MAX_ARGS; i++)
    {
        argv[i]=strtok(NULL, " ");
        if(argv[i] == NULL)
            break;
    }

    execv(argv[0], argv);

    perror("exec");
}

void do_pcommand(char *prog)
{
    int stat;

    /* Fork a child to run the command, and wait for the child */

    if(fork()==0)
        runCommand(prog);
    else
        wait(&stat);
}

void showps(char *arg)
{
    char buf[1024];

    if(arg != NULL)
    {
      /*
       * This section is a bit ugly, but the availability of the ps programs
       * is determined at compile time, so I should only compile in what
       * I'll be using.
       */

        if(arg[0] == '-')
        {
#ifndef SYSVPS
            puts("Sorry, but SYSV PS is not available.");
#else
            strcpy(buf, SYSVPS);
            strcat(buf, " ");
            strcat(buf, arg);
            do_pcommand(buf);  /* This repeated so that it won't get
                                  included if not available. */
#endif
        }
        else
        {
#ifndef BSDPS
            puts("Sorry, but BSD style PS is not available.");
#else

            strcpy(buf, BSDPS);
            strcat(buf, " ");
            strcat(buf, arg);
            do_pcommand(buf);
#endif
        }
    }
    else
    {
        strcpy(buf, DEFAULTPS);
        do_pcommand(buf);
    }

    /* EOF at the bottom */
    puts("EOF");
    fflush(stdout);
}
