/*
 * Copyright (c) 1997  Dustin Sallings
 *
 * $Id: users.c,v 1.11 1997/09/10 07:20:50 dustin Exp $
 */

#include <config.h>
#include <stdio.h>
#include <stdlib.h>

#include <string.h>
#include <utmp.h>
#include <time.h>
#include <sys/stat.h>

#ifndef _PATH_UTMP
#  ifdef UTMP_FILE
#    define _PATH_UTMP UTMP_FILE
#  else
#    ifdef PATH_UTMP
#      define _PATH_UTMP PATH_UTMP
#    else
#      define _PATH_UTMP UTMPFILE
#    endif
#  endif 
#endif

#ifndef _PATH_WTMP
#  ifdef WTMP_FILE
#    define _PATH_WTMP WTMP_FILE
#  else
#    ifdef PATH_WTMP
#      define _PATH_WTMP PATH_WTMP
#    else
#      define _PATH_WTMP "/etc/wtmp"
#    endif
#  endif 
#endif

/*
 * Damnit, why everybody gotta be different?
 */

#if BSDLIKE && !defined(_AIX)
#define ut_name ut_name
#endif

#ifndef ut_name
#define ut_name ut_user
#endif

int checkidle(char *line)
{
    time_t clock;
    struct stat st;
    char path[20];

    strcpy(path, "/dev/");
    strcat(path, line);
    stat(path, &st);

    clock=time(NULL);
    clock-=st.st_mtime;
    return(clock);
}

int countusers(void)
{
    int i=0;
    struct utmp *u;
#ifndef HAVE_GETUTENT
    FILE *f;

    u=(struct utmp *)malloc(sizeof(struct utmp));

    if( (f=fopen(_PATH_UTMP, "rb"))==NULL)
    {
	perror(_PATH_UTMP);
	return(-1);
    }

    for(;;)
    {
	fread(u, sizeof(struct utmp), 1, f);
	if(feof(f)) break;
#else
    while(u=getutent())
    {
#endif /* have getutent() */

#if (BSDLIKE == 0)
        if(u->ut_type==USER_PROCESS)
#else
        if(u->ut_name[0] != 0x00)
#endif /* sysv */
	    i++;
    }

#ifndef HAVE_GETUTENT
    fclose(f);
    free(u);
#else
    endutent();
#endif

    return(i);
}

int listusers(void)
{
    struct utmp *u;
    char un[9];
#ifndef HAVE_GETUTENT
    FILE *f;

    u=(struct utmp *)malloc(sizeof(struct utmp));

    if( (f=fopen(_PATH_UTMP, "rb"))==NULL)
    {
	perror(_PATH_UTMP);
	return(-1);
    }

    for(;;)
    {
	fread(u, sizeof(struct utmp), 1, f);
	if(feof(f)) break;
#else
    while(u=getutent())
    {
#endif
#if (BSDLIKE == 0)
        if(u->ut_type == USER_PROCESS)
#else
	if(u->ut_name[0] != 0x00)
#endif
	{
	    strncpy(un, u->ut_name, 8);
	    un[8]=0x00;
            printf("%s;%d\n", un, checkidle(u->ut_line));
	}
    }

#ifndef HAVE_GETUTENT
    free(u);
    fclose(f);
#else
    endutent();
#endif

    return(0);
}

void numusers(char  *arg)
{
    printf("%d\n", countusers());
}

void who(char *arg)
{
    listusers();
}
